/** Copyright (C) 2017 by Bundesanstalt für Gewässerkunde
 * Software engineering by
 *  Björnsen Beratende Ingenieure GmbH
 *  Dr. Schumacher Ingenieurbüro für Wasser und Umwelt
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */
package org.dive4elements.river.client.client.ui;

import com.smartgwt.client.widgets.form.validator.IntegerRangeValidator;
import com.smartgwt.client.widgets.grid.ListGridField;
import com.smartgwt.client.widgets.grid.SortNormalizer;
import com.smartgwt.client.widgets.grid.events.CellSavedEvent;
import com.smartgwt.client.widgets.grid.events.CellSavedHandler;

/**
 * @author Domenico Nardi Tironi
 *
 */
public class VegZonePanelHelper {

    public VegZonePanelHelper() {

    }

    public static ListGridField createIntTableField(final String key, final String msg, final boolean canSort, final SortNormalizer normalizer,
            final IntegerRangeValidator validators) {
        final ListGridField intField = PanelHelper.createIntTableField(key, msg, canSort, normalizer, validators);
        intField.addCellSavedHandler(new CellSavedHandler() { // wirkungslos, wenn int-validator bereits vorhanden ist..
            @Override
            public void onCellSaved(final CellSavedEvent event) {
                final Object value = event.getNewValue();
                event.getRecord().setAttribute(key, event.getOldValue());
                try {
                    final int intValue = Integer.valueOf(String.valueOf(value));
                    event.getRecord().setAttribute(key, intValue);
                }
                catch (final NumberFormatException e) {
                    e.printStackTrace();
                }
            }
        });
        return intField;

    }

}
